//+------------------------------------------------------------------+
//|                                                           rsi ma |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  OrangeRed
#property indicator_color3  OrangeRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum -1
#property indicator_maximum 101

//
//
//
//
//

extern int RsiPeriod = 14;
extern int RsiPrice  = PRICE_CLOSE;

//
//
//
//
//

double values[];
double valuesDa[];
double valuesDb[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,values);
      SetIndexBuffer(1,valuesDa);
      SetIndexBuffer(2,valuesDb);
      SetIndexBuffer(3,trend);
   IndicatorShortName("rsi ma )"+RsiPeriod+")");
   return(0); 
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   if (trend[limit]==-1) CleanPoint(limit,valuesDa,valuesDb);
   for(i=limit; i>=0; i--)
   {
      int maSlope   = (iMA(NULL,0,RsiPeriod,0,MODE_EMA,PRICE_WEIGHTED,i)-iMA(NULL,0,RsiPeriod,0,MODE_EMA,PRICE_WEIGHTED,i+1))/Point;
          values[i] = MathMax(MathMin(iRSI(NULL,0,RsiPeriod,RsiPrice,i)*maSlope,100),0);
          valuesDa[i] = EMPTY_VALUE;
          valuesDb[i] = EMPTY_VALUE;
          trend[i]    = trend[i+1];

          if (values[i]>values[i+1]) trend[i] =  1;
          if (values[i]<values[i+1]) trend[i] = -1;
          if (trend[i]==-1) PlotPoint(i,valuesDa,valuesDb,values);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}